import 'package:healthrian_common_support/healthrian_common_support.dart';

class CommandsFunctionBuiltin {
  static const List<int> preamble = [0x48, 0x52];

  static List<int> packet(List<int> command, [List<int> data = const []]) {
    if (command.isEmpty) return [];
    final payload = _payload(command, data);
    return [
      ...preamble,
      ..._size(payload),
      ...payload,
      ..._crc(payload),
    ];
  }

  static List<int> _payload(List<int> command, List<int> data) {
    return [
      ...command,
      ...data,
    ];
  }

  static List<int> _size(List<int> payload) {
    return [
      payload.length,
    ];
  }

  static List<int> _crc(List<int> payload) {
    return Crc16.getCcittFalse(payload);
  }

  static List<int> date() {
    final dateTime = DateTime.now();
    return [
      dateTime.year >> 8,
      dateTime.year & 0xFF,
      dateTime.month,
      dateTime.day,
      dateTime.hour,
      dateTime.minute,
      dateTime.second,
    ];
  }
}

class CommandsFunction {
  const CommandsFunction({
    this.packet = CommandsFunctionBuiltin.packet,
    this.date = CommandsFunctionBuiltin.date,
  });

  final List<int> Function(List<int>, [List<int>]) packet;
  final List<int> Function() date;
}
