import 'dart:developer' as dev;

import 'package:flutter_blue_plus/flutter_blue_plus.dart';

extension ObjectLogging on Object {
  void get log {
    dev.log('$this');
  }
}

extension PacketLogging on List<int> {
  void get packetLog {
    'Write a packet $this'.log;
  }
}

extension BLEWriteLogging on BluetoothCharacteristic {
  Future<void> writePacket(List<int> packet) async {
    packet.packetLog;
    await write(packet);
  }
}

extension BLEWriteLoggingNullable on BluetoothCharacteristic? {
  Future<void> writePacket(List<int> packet) async {
    '$this writePacket with $packet'.log;
    if (this == null) return;
    '$this writePacket with {this == null}'.log;
    if(packet.isEmpty) return;
    '$this writePacket with {packet.isEmpty}'.log;
    await this!.writePacket(packet);
  }
}
